'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

var _load = require('./load');

var _load2 = _interopRequireDefault(_load);

var unpersistedQueue = {};
var isUpdating = {};

exports['default'] = function (db) {
  var loadReducer = (0, _load2['default'])(db);

  var saveReducer = function saveReducer(reducerName, reducerState) {
    if (isUpdating[reducerName]) {
      console.log('unpersisted enqueue', unpersistedQueue, reducerState);
      //enqueue promise
      unpersistedQueue[reducerName] = unpersistedQueue[reducerName] || [];
      unpersistedQueue[reducerName].push(reducerState);

      return Promise.resolve();
    }

    isUpdating[reducerName] = true;
    console.log('isUpdating:', reducerName, typeof reducerName);

    return loadReducer(reducerName).then(function (doc) {
      console.log('after load');
      var newDoc = _extends({}, doc);

      if (Array.isArray(reducerState)) {
        newDoc.state = [].concat(_toConsumableArray(doc.state || []), _toConsumableArray(reducerState));
      } else {
        newDoc.state = _extends({}, doc.state, reducerState);
      }

      return newDoc;
    }).then(function (newDoc) {
      console.log('try put:', newDoc._id);
      console.log(newDoc);

      return db.put(newDoc);
    }).then(function () {
      isUpdating[reducerName] = false;
      console.log('hasUpdated:', reducerName);
    }).then(function () {
      console.log('unpersistedQueue', unpersistedQueue);
      if (unpersistedQueue[reducerName]) {
        var next = unpersistedQueue[reducerName].shift();
        console.log('next', reducerName, next);

        return saveReducer(next);
      }
    })['catch'](console.log.bind(console));
  };

  return saveReducer;
};

module.exports = exports['default'];